Mycodo ist ein quelloffenes Umweltüberwachungs- und -regulierungssystem, das für den Betrieb auf Einplatinencomputern, insbesondere dem [Raspberry Pi](https://en.wikipedia.org/wiki/Raspberry_Pi), entwickelt wurde.

Ursprünglich für die Zucht von Speisepilzen entwickelt, kann Mycodo inzwischen viel mehr. Das System besteht aus zwei Teilen, einem Backend (Daemon) und einem Frontend (Webserver). Das Backend übernimmt Aufgaben wie die Erfassung von Messwerten von Sensoren und Geräten und koordiniert eine Reihe von Reaktionen auf diese Messwerte, einschließlich der Fähigkeit, Ausgänge zu modulieren (Relais schalten, PWM-Signale erzeugen, Pumpen betreiben, drahtlose Ausgänge schalten, MQTT veröffentlichen/abonnieren usw.), Umgebungsbedingungen mit PID-Steuerung zu regulieren, Zeitpläne zu erstellen, Fotos aufzunehmen und Videos zu streamen, Aktionen auszulösen, wenn Messwerte bestimmte Bedingungen erfüllen, und vieles mehr. Das Frontend beherbergt eine Weboberfläche, die Anzeige und Konfiguration von jedem Browser-fähigen Gerät aus ermöglicht.

Für Mycodo gibt es eine Reihe von unterschiedlichen Verwendungszwecken. Einige Nutzer speichern einfach Sensormessungen, um die Bedingungen aus der Ferne zu überwachen, andere regulieren die Umgebungsbedingungen eines physischen Raums, während andere unter anderem bewegungsaktivierte oder Zeitrafferaufnahmen machen.

Input-Controller erfassen Messwerte und speichern sie in der InfluxDB-Zeitreihendatenbank. Die Messungen stammen in der Regel von Sensoren, können aber auch so konfiguriert werden, dass sie den Rückgabewert von Linux-Bash- oder Python-Befehlen oder mathematische Gleichungen verwenden, was dieses System zu einem sehr dynamischen System für die Erfassung und Erzeugung von Daten macht.

Ausgangssteuerungen erzeugen Änderungen an den GPIO-Pins (GPIO = General Input/Output) oder können so konfiguriert werden, dass sie Linux-Bash- oder Python-Befehle ausführen, was eine Vielzahl von Verwendungsmöglichkeiten bietet. Es gibt einige verschiedene Arten von Ausgängen: einfaches Schalten von GPIO-Pins (HIGH/LOW), Erzeugen von pulsweitenmodulierten (PWM) Signalen, Steuern von Schlauchpumpen, MQTT-Veröffentlichung und mehr.

Wenn Eingänge und Ausgänge kombiniert werden, können Funktionsregler verwendet werden, um Rückkopplungsschleifen zu erstellen, die das Ausgangsgerät verwenden, um einen Umgebungszustand zu modulieren, den der Eingang misst. Bestimmte Eingänge können mit bestimmten Ausgängen gekoppelt werden, um eine Vielzahl verschiedener Steuerungs- und Regelungsanwendungen zu schaffen. Über die einfache Regelung hinaus können Methoden verwendet werden, um einen sich im Laufe der Zeit ändernden Sollwert zu erzeugen, was z. B. Thermocycler, Reflow-Öfen, Umweltsimulationen für Terrarien, Fermentierung oder Reifung von Lebensmitteln und Getränken sowie das Garen von Lebensmitteln ([Sous-vide](https://en.wikipedia.org/wiki/Sous-vide)) ermöglicht, um nur einige Beispiele zu nennen.

Auslöser können so eingestellt werden, dass sie Ereignisse auf der Grundlage bestimmter Daten und Uhrzeiten, Zeitspannen oder des Sonnenaufgangs/Sonnenuntergangs an einem bestimmten Breiten- und Längengrad aktivieren.

Mycodo wurde in mehrere Sprachen übersetzt. Standardmäßig bestimmt die Sprache des Browsers, welche Sprache verwendet wird, kann aber in den allgemeinen Einstellungen auf der Seite "Zahnradsymbol" -> "Konfigurieren" -> "Allgemein" überschrieben werden. Wenn Sie ein Problem finden und eine Übersetzung korrigieren oder eine weitere Sprache hinzufügen möchten, können Sie dies unter [https://translate.kylegabriel.com](http://translate.kylegabriel.com:8080/engage/mycodo/) tun.
