Mycodo es un sistema de supervisión y regulación medioambiental de código abierto que se ha creado para funcionar en ordenadores de placa única, concretamente en la [Raspberry Pi](https://en.wikipedia.org/wiki/Raspberry_Pi).

Desarrollado originalmente para el cultivo de setas comestibles, Mycodo ha crecido para hacer mucho más. El sistema consta de dos partes, un backend (demonio) y un frontend (servidor web). El backend realiza tareas como la adquisición de mediciones de sensores y dispositivos y la coordinación de un conjunto diverso de respuestas a esas mediciones, incluida la capacidad de modular las salidas (conmutar relés, generar señales PWM, operar bombas, conmutar salidas inalámbricas, publicar/suscribirse a MQTT, entre otras), regular las condiciones ambientales con control PID, programar temporizadores, capturar fotos y transmitir vídeo, desencadenar acciones cuando las mediciones cumplen ciertas condiciones, y más. El frontend alberga una interfaz web que permite la visualización y configuración desde cualquier dispositivo con navegador.

Los usos de Mycodo son muy variados. Algunos usuarios simplemente almacenan las mediciones de los sensores para supervisar las condiciones a distancia, otros regulan las condiciones ambientales de un espacio físico, mientras que otros capturan fotografías activadas por el movimiento o por el tiempo, entre otros usos.

Los controladores de entrada adquieren mediciones y las almacenan en la base de datos de series temporales InfluxDB. Las mediciones suelen proceder de los sensores, pero también pueden configurarse para utilizar el valor de retorno de los comandos de Linux Bash o Python, o las ecuaciones matemáticas, lo que hace que sea un sistema muy dinámico para adquirir y generar datos.

Los controladores de salida producen cambios en los pines generales de entrada/salida (GPIO) o pueden ser configurados para ejecutar comandos de Linux Bash o Python, permitiendo una variedad de usos potenciales. Existen varios tipos de salidas: la simple conmutación de los pines GPIO (HIGH/LOW), la generación de señales de ancho de pulso modulado (PWM), el control de bombas peristálticas, la publicación de MQTT, etc.

Cuando se combinan las Entradas y las Salidas, los controladores de funciones pueden utilizarse para crear bucles de retroalimentación que utilizan el dispositivo de Salida para modular una condición ambiental que la Entrada mide. Ciertas Entradas pueden ser acopladas con ciertas Salidas para crear una variedad de diferentes aplicaciones de control y regulación. Más allá de la simple regulación, los Métodos pueden ser utilizados para crear un punto de ajuste cambiante en el tiempo, permitiendo cosas como cicladores térmicos, hornos de reflujo, simulación ambiental para terrarios, fermentación o curado de alimentos y bebidas, y cocción de alimentos ([sous-vide](https://en.wikipedia.org/wiki/Sous-vide)), por nombrar algunos.

Los disparadores se pueden configurar para activar eventos basados en fechas y horas específicas, según duraciones de tiempo, o la salida/puesta del sol en una latitud y longitud específicas.

Mycodo ha sido traducido a varios idiomas. Por defecto, el idioma del navegador determinará qué idioma se utiliza, pero se puede anular en la Configuración General, en la página `[Icono del engranaje] -> Configurar -> General`. Si encuentras un problema y quieres corregir una traducción o quieres añadir otro idioma, puedes hacerlo en [https://translate.kylegabriel.com](http://translate.kylegabriel.com:8080/engage/mycodo/).
