Mycodo est un système open-source de surveillance et de régulation de l'environnement conçu pour fonctionner sur des ordinateurs monocartes, notamment le [Raspberry Pi](https://en.wikipedia.org/wiki/Raspberry_Pi).

Développé à l'origine pour la culture de champignons comestibles, Mycodo s'est développé pour faire beaucoup plus. Le système se compose de deux parties, un backend (démon) et un frontend (serveur web). Le backend effectue des tâches telles que l'acquisition de mesures à partir de capteurs et de dispositifs et la coordination d'un ensemble diversifié de réponses à ces mesures, y compris la capacité de moduler les sorties (commutation de relais, génération de signaux PWM, fonctionnement de pompes, commutation de prises sans fil, publication/abonnement à MQTT, entre autres), de réguler les conditions environnementales avec un contrôle PID, de programmer des minuteries, de capturer des photos et de diffuser des vidéos, de déclencher des actions lorsque les mesures répondent à certaines conditions, etc. Le frontal héberge une interface web qui permet de visualiser et de configurer les appareils à partir de n'importe quel navigateur.

Il existe un certain nombre d'utilisations différentes de Mycodo. Certains utilisateurs stockent simplement les mesures des capteurs pour surveiller les conditions à distance, d'autres régulent les conditions environnementales d'un espace physique, tandis que d'autres capturent des photographies activées par le mouvement ou en time-lapse, entre autres utilisations.

Les contrôleurs d'entrée acquièrent des mesures et les stockent dans la base de données de séries temporelles InfluxDB. Les mesures proviennent généralement de capteurs, mais peuvent également être configurées pour utiliser la valeur de retour de commandes Linux Bash ou Python, ou d'équations mathématiques, ce qui en fait un système très dynamique d'acquisition et de génération de données.

Les contrôleurs de sortie produisent des changements sur les broches d'entrée/sortie générales (GPIO) ou peuvent être configurés pour exécuter des commandes Linux Bash ou Python, ce qui permet une variété d'utilisations potentielles. Il existe différents types de sorties : la simple commutation des broches GPIO (HAUT/BAS), la génération de signaux modulés en largeur d'impulsion (PWM), le contrôle de pompes péristaltiques, la publication MQTT, etc.

Lorsque les entrées et les sorties sont combinées, les contrôleurs de fonction peuvent être utilisés pour créer des boucles de rétroaction qui utilisent le dispositif de sortie pour moduler une condition environnementale mesurée par l'entrée. Certaines entrées peuvent être couplées à certaines sorties pour créer une variété d'applications de contrôle et de régulation différentes. Au-delà de la simple régulation, les méthodes peuvent être utilisées pour créer un point de consigne changeant au fil du temps, permettant des choses telles que les thermocycleurs, les fours de refusion, la simulation environnementale pour les terrariums, la fermentation ou le séchage des aliments et des boissons, et la cuisson des aliments ([sous-vide](https://en.wikipedia.org/wiki/Sous-vide)), pour n'en citer que quelques-unes.

Les déclencheurs peuvent être configurés pour activer des événements en fonction de dates et d'heures spécifiques, en fonction de durées, ou du lever/coucher du soleil à une latitude et une longitude spécifiques.

Mycodo a été traduit en plusieurs langues. Par défaut, la langue du navigateur déterminera la langue utilisée, mais peut être remplacée dans les paramètres généraux, sur la page `[Gear Icon] -> Configure -> General`. Si vous rencontrez un problème et que vous souhaitez corriger une traduction ou ajouter une autre langue, vous pouvez le faire à l'adresse [https://translate.kylegabriel.com](http://translate.kylegabriel.com:8080/engage/mycodo/).
