Mycodo adalah sistem pemantauan dan pengaturan lingkungan bersumber terbuka yang dibangun untuk dijalankan pada komputer papan tunggal, khususnya [Raspberry Pi](https://en.wikipedia.org/wiki/Raspberry_Pi).

Awalnya dikembangkan untuk membudidayakan jamur yang dapat dimakan, Mycodo telah berkembang untuk melakukan lebih banyak lagi. Sistem ini terdiri atas dua bagian, backend (daemon) dan frontend (server web). Backend melakukan tugas-tugas seperti memperoleh pengukuran dari sensor dan perangkat dan mengoordinasikan beragam respons terhadap pengukuran tersebut, termasuk kemampuan untuk memodulasi output (mengganti relay, menghasilkan sinyal PWM, mengoperasikan pompa, mengganti outlet nirkabel, menerbitkan / berlangganan MQTT, antara lain), mengatur kondisi lingkungan dengan kontrol PID, menjadwalkan pengatur waktu, mengambil foto dan streaming video, memicu tindakan ketika pengukuran memenuhi kondisi tertentu, dan banyak lagi. Frontend menjadi tuan rumah antarmuka web yang memungkinkan tampilan dan konfigurasi dari perangkat berkemampuan browser apa pun.

Ada sejumlah kegunaan berbeda untuk Mycodo. Beberapa pengguna hanya menyimpan pengukuran sensor untuk memantau kondisi dari jarak jauh, yang lain mengatur kondisi lingkungan ruang fisik, sementara yang lain menangkap fotografi yang diaktifkan gerakan atau selang waktu, di antara kegunaan lainnya.

Pengontrol input memperoleh pengukuran dan menyimpannya dalam basis data deret waktu InfluxDB. Pengukuran biasanya berasal dari sensor, tetapi juga dapat dikonfigurasi untuk menggunakan nilai balik dari perintah Linux Bash atau Python, atau persamaan matematika, menjadikannya sistem yang sangat dinamis untuk memperoleh dan menghasilkan data.

Pengontrol output menghasilkan perubahan pada pin input/output umum (GPIO) atau dapat dikonfigurasi untuk menjalankan perintah Linux Bash atau Python, memungkinkan berbagai potensi penggunaan. Ada beberapa jenis output yang berbeda: peralihan sederhana pin GPIO (HIGH/LOW), menghasilkan sinyal pulse-width modulated (PWM), mengendalikan pompa peristaltik, penerbitan MQTT, dan banyak lagi.

Ketika Input dan Output digabungkan, Pengontrol fungsi dapat digunakan untuk membuat loop umpan balik yang menggunakan perangkat Output untuk memodulasi kondisi lingkungan yang diukur Input. Input tertentu dapat digabungkan dengan Output tertentu untuk membuat berbagai aplikasi kontrol dan regulasi yang berbeda. Di luar regulasi sederhana, Metode dapat digunakan untuk membuat setpoint yang berubah dari waktu ke waktu, memungkinkan hal-hal seperti thermal cyclers, oven reflow, simulasi lingkungan untuk terarium, fermentasi atau pengawetan makanan dan minuman, dan memasak makanan ([sous-vide](https://en.wikipedia.org/wiki/Sous-vide)), untuk beberapa nama.

Pemicu bisa ditetapkan untuk mengaktifkan peristiwa berdasarkan tanggal dan waktu tertentu, menurut durasi waktu, atau matahari terbit/terbenam pada garis lintang dan garis bujur tertentu.

Mycodo telah diterjemahkan ke beberapa bahasa. Secara default, bahasa browser akan menentukan bahasa mana yang digunakan, tetapi dapat diganti di Pengaturan Umum, pada `[Ikon Roda Gigi] -> Konfigurasi -> Halaman Umum`. Jika Anda menemukan masalah dan ingin mengoreksi terjemahan atau ingin menambahkan bahasa lain, hal ini dapat dilakukan di [https://translate.kylegabriel.com](http://translate.kylegabriel.com:8080/engage/mycodo/).
