Measurements

 - [Acceleration](#acceleration)
 - [Acceleration (X)](#acceleration-x)
 - [Acceleration (Y)](#acceleration-y)
 - [Acceleration (Z)](#acceleration-z)
 - [ADC](#adc)
 - [Altitude](#altitude)
 - [Angle](#angle)
 - [Battery](#battery)
 - [Boolean](#boolean)
 - [Carbon Dioxide](#carbon-dioxide)
 - [Color (Y)](#color-y)
 - [Color (Blue)](#color-blue)
 - [Color (Green)](#color-green)
 - [Color (Red)](#color-red)
 - [Color (x)](#color-x)
 - [Color (y)](#color-y)
 - [CPU Load (15 Minutes)](#cpu-load-15-minutes)
 - [CPU Load (1 Minute)](#cpu-load-1-minute)
 - [CPU Load (5 Minutes)](#cpu-load-5-minutes)
 - [Dewpoint](#dewpoint)
 - [Direction](#direction)
 - [Disk](#disk)
 - [Dissolved Oxygen](#dissolved-oxygen)
 - [Duration](#duration)
 - [Duty Cycle](#duty-cycle)
 - [GPIO Edge](#gpio-edge)
 - [Electrical Conductivity](#electrical-conductivity)
 - [Electrical Current](#electrical-current)
 - [Electrical Potential](#electrical-potential)
 - [Energy](#energy)
 - [Frequency](#frequency)
 - [GPIO State](#gpio-state)
 - [Humidity](#humidity)
 - [Ion Concentration](#ion-concentration)
 - [Length](#length)
 - [Light](#light)
 - [Magnetic Flux Density](#magnetic-flux-density)
 - [Methane](#methane)
 - [Moisture](#moisture)
 - [Oxygen](#oxygen)
 - [Oxidation Reduction Potential](#oxidation-reduction-potential)
 - [PM10](#pm10)
 - [PM1](#pm1)
 - [PM2.5](#pm25)
 - [Power](#power)
 - [Apparent Power](#apparent-power)
 - [Power Factor](#power-factor)
 - [Reactive Power](#reactive-power)
 - [Pressure](#pressure)
 - [Pulse Width](#pulse-width)
 - [Volume Flow Rate](#volume-flow-rate)
 - [Resistance](#resistance)
 - [Revolutions](#revolutions)
 - [Salinity](#salinity)
 - [Specific Gravity](#specific-gravity)
 - [Speed](#speed)
 - [Temperature](#temperature)
 - [Total Dissolved Solids](#total-dissolved-solids)
 - [Vapor Pressure Deficit](#vapor-pressure-deficit)
 - [Version](#version)
 - [VOC](#voc)
 - [Volume](#volume)

## Acceleration

### [Ruuvi: RuuviTag](/Mycodo/Supported-Inputs/#ruuvi-ruuvitag)

## Acceleration (X)

### [Analog Devices: ADXL34x (343, 344, 345, 346)](/Mycodo/Supported-Inputs/#analog-devices-adxl34x-343-344-345-346)

### [Raspberry Pi Foundation: Sense HAT](/Mycodo/Supported-Inputs/#raspberry-pi-foundation-sense-hat)

### [Ruuvi: RuuviTag](/Mycodo/Supported-Inputs/#ruuvi-ruuvitag)

## Acceleration (Y)

### [Analog Devices: ADXL34x (343, 344, 345, 346)](/Mycodo/Supported-Inputs/#analog-devices-adxl34x-343-344-345-346)

### [Raspberry Pi Foundation: Sense HAT](/Mycodo/Supported-Inputs/#raspberry-pi-foundation-sense-hat)

### [Ruuvi: RuuviTag](/Mycodo/Supported-Inputs/#ruuvi-ruuvitag)

## Acceleration (Z)

### [Analog Devices: ADXL34x (343, 344, 345, 346)](/Mycodo/Supported-Inputs/#analog-devices-adxl34x-343-344-345-346)

### [Raspberry Pi Foundation: Sense HAT](/Mycodo/Supported-Inputs/#raspberry-pi-foundation-sense-hat)

### [Ruuvi: RuuviTag](/Mycodo/Supported-Inputs/#ruuvi-ruuvitag)

## ADC

### [AMS: AS7262](/Mycodo/Supported-Inputs/#ams-as7262)

## Altitude

### [BOSCH: BME280](/Mycodo/Supported-Inputs/#bosch-bme280)

### [BOSCH: BME280](/Mycodo/Supported-Inputs/#bosch-bme280)

### [BOSCH: BME280](/Mycodo/Supported-Inputs/#bosch-bme280)

### [BOSCH: BME680](/Mycodo/Supported-Inputs/#bosch-bme680)

### [BOSCH: BME680](/Mycodo/Supported-Inputs/#bosch-bme680)

### [BOSCH: BMP180](/Mycodo/Supported-Inputs/#bosch-bmp180)

### [BOSCH: BMP280](/Mycodo/Supported-Inputs/#bosch-bmp280)

### [BOSCH: BMP280](/Mycodo/Supported-Inputs/#bosch-bmp280)

### [Senseair: K96](/Mycodo/Supported-Inputs/#senseair-k96)

## Angle

### [Raspberry Pi Foundation: Sense HAT](/Mycodo/Supported-Inputs/#raspberry-pi-foundation-sense-hat)

## Battery

### [Ruuvi: RuuviTag](/Mycodo/Supported-Inputs/#ruuvi-ruuvitag)

### [Sensorion: SHT31 Smart Gadget](/Mycodo/Supported-Inputs/#sensorion-sht31-smart-gadget)

### [Xiaomi: Miflora](/Mycodo/Supported-Inputs/#xiaomi-miflora)

### [Xiaomi: Mijia LYWSD03MMC (ATC and non-ATC modes)](/Mycodo/Supported-Inputs/#xiaomi-mijia-lywsd03mmc-atc-and-non-atc-modes)

## Boolean

### [Mycodo: Output State (On/Off)](/Mycodo/Supported-Inputs/#mycodo-output-state-on-off)

### [Mycodo: Server Ping](/Mycodo/Supported-Inputs/#mycodo-server-ping)

### [Mycodo: Server Port Open](/Mycodo/Supported-Inputs/#mycodo-server-port-open)

## Carbon Dioxide

### [AMS: CCS811 (with Temperature)](/Mycodo/Supported-Inputs/#ams-ccs811-with-temperature)

### [AMS: CCS811 (without Temperature)](/Mycodo/Supported-Inputs/#ams-ccs811-without-temperature)

### [Atlas Scientific: Atlas CO2 (Carbon Dioxide Gas)](/Mycodo/Supported-Inputs/#atlas-scientific-atlas-co2-carbon-dioxide-gas)

### [CO2Meter: K30](/Mycodo/Supported-Inputs/#co2meter-k30)

### [Cozir: Cozir CO2](/Mycodo/Supported-Inputs/#cozir-cozir-co2)

### [Senseair: K96](/Mycodo/Supported-Inputs/#senseair-k96)

### [Sensirion: SCD-4x (40, 41)](/Mycodo/Supported-Inputs/#sensirion-scd-4x-40-41)

### [Sensirion: SCD30](/Mycodo/Supported-Inputs/#sensirion-scd30)

### [Sensirion: SCD30](/Mycodo/Supported-Inputs/#sensirion-scd30)

### [Winsen: MH-Z14A](/Mycodo/Supported-Inputs/#winsen-mh-z14a)

### [Winsen: MH-Z16](/Mycodo/Supported-Inputs/#winsen-mh-z16)

### [Winsen: MH-Z19](/Mycodo/Supported-Inputs/#winsen-mh-z19)

### [Winsen: MH-Z19B](/Mycodo/Supported-Inputs/#winsen-mh-z19b)

## Color (Y)

### [Atlas Scientific: Atlas Color](/Mycodo/Supported-Inputs/#atlas-scientific-atlas-color)

## Color (Blue)

### [Atlas Scientific: Atlas Color](/Mycodo/Supported-Inputs/#atlas-scientific-atlas-color)

## Color (Green)

### [Atlas Scientific: Atlas Color](/Mycodo/Supported-Inputs/#atlas-scientific-atlas-color)

## Color (Red)

### [Atlas Scientific: Atlas Color](/Mycodo/Supported-Inputs/#atlas-scientific-atlas-color)

## Color (x)

### [Atlas Scientific: Atlas Color](/Mycodo/Supported-Inputs/#atlas-scientific-atlas-color)

## Color (y)

### [Atlas Scientific: Atlas Color](/Mycodo/Supported-Inputs/#atlas-scientific-atlas-color)

## CPU Load (15 Minutes)

### [Mycodo: CPU Load](/Mycodo/Supported-Inputs/#mycodo-cpu-load)

## CPU Load (1 Minute)

### [Mycodo: CPU Load](/Mycodo/Supported-Inputs/#mycodo-cpu-load)

## CPU Load (5 Minutes)

### [Mycodo: CPU Load](/Mycodo/Supported-Inputs/#mycodo-cpu-load)

## Dewpoint

### [AOSONG: AM2315/AM2320](/Mycodo/Supported-Inputs/#aosong-am2315-am2320)

### [AOSONG: DHT11](/Mycodo/Supported-Inputs/#aosong-dht11)

### [AOSONG: DHT22](/Mycodo/Supported-Inputs/#aosong-dht22)

### [Atlas Scientific: Atlas Humidity](/Mycodo/Supported-Inputs/#atlas-scientific-atlas-humidity)

### [BOSCH: BME280](/Mycodo/Supported-Inputs/#bosch-bme280)

### [BOSCH: BME280](/Mycodo/Supported-Inputs/#bosch-bme280)

### [BOSCH: BME280](/Mycodo/Supported-Inputs/#bosch-bme280)

### [BOSCH: BME680](/Mycodo/Supported-Inputs/#bosch-bme680)

### [BOSCH: BME680](/Mycodo/Supported-Inputs/#bosch-bme680)

### [Cozir: Cozir CO2](/Mycodo/Supported-Inputs/#cozir-cozir-co2)

### [Ruuvi: RuuviTag](/Mycodo/Supported-Inputs/#ruuvi-ruuvitag)

### [Seeedstudio: DHT11/22](/Mycodo/Supported-Inputs/#seeedstudio-dht11-22)

### [Senseair: K96](/Mycodo/Supported-Inputs/#senseair-k96)

### [Sensirion: SCD-4x (40, 41)](/Mycodo/Supported-Inputs/#sensirion-scd-4x-40-41)

### [Sensirion: SCD30](/Mycodo/Supported-Inputs/#sensirion-scd30)

### [Sensirion: SCD30](/Mycodo/Supported-Inputs/#sensirion-scd30)

### [Sensirion: SHT1x/7x](/Mycodo/Supported-Inputs/#sensirion-sht1x-7x)

### [Sensirion: SHT2x](/Mycodo/Supported-Inputs/#sensirion-sht2x)

### [Sensirion: SHT2x](/Mycodo/Supported-Inputs/#sensirion-sht2x)

### [Sensirion: SHT31-D](/Mycodo/Supported-Inputs/#sensirion-sht31-d)

### [Sensirion: SHT3x (30, 31, 35)](/Mycodo/Supported-Inputs/#sensirion-sht3x-30-31-35)

### [Sensirion: SHT4X](/Mycodo/Supported-Inputs/#sensirion-sht4x)

### [Sensirion: SHTC3](/Mycodo/Supported-Inputs/#sensirion-shtc3)

### [Sensorion: SHT31 Smart Gadget](/Mycodo/Supported-Inputs/#sensorion-sht31-smart-gadget)

### [Silicon Labs: Si7021](/Mycodo/Supported-Inputs/#silicon-labs-si7021)

### [Sonoff: TH16/10 (Tasmota firmware) with AM2301/Si7021](/Mycodo/Supported-Inputs/#sonoff-th16-10-tasmota-firmware-with-am2301-si7021)

### [Sonoff: TH16/10 (Tasmota firmware) with AM2301](/Mycodo/Supported-Inputs/#sonoff-th16-10-tasmota-firmware-with-am2301)

### [TE Connectivity: HTU21D](/Mycodo/Supported-Inputs/#te-connectivity-htu21d)

### [TE Connectivity: HTU21D](/Mycodo/Supported-Inputs/#te-connectivity-htu21d)

### [Texas Instruments: HDC1000](/Mycodo/Supported-Inputs/#texas-instruments-hdc1000)

### [Weather: OpenWeatherMap (City, Current)](/Mycodo/Supported-Inputs/#weather-openweathermap-city-current)

### [Weather: OpenWeatherMap (Lat/Lon, Current/Future)](/Mycodo/Supported-Inputs/#weather-openweathermap-lat-lon-current-future)

## Direction

### [Raspberry Pi Foundation: Sense HAT](/Mycodo/Supported-Inputs/#raspberry-pi-foundation-sense-hat)

### [Weather: OpenWeatherMap (City, Current)](/Mycodo/Supported-Inputs/#weather-openweathermap-city-current)

### [Weather: OpenWeatherMap (Lat/Lon, Current/Future)](/Mycodo/Supported-Inputs/#weather-openweathermap-lat-lon-current-future)

## Disk

### [Mycodo: Free Space](/Mycodo/Supported-Inputs/#mycodo-free-space)

### [Mycodo: Mycodo RAM](/Mycodo/Supported-Inputs/#mycodo-mycodo-ram)

## Dissolved Oxygen

### [Atlas Scientific: Atlas DO](/Mycodo/Supported-Inputs/#atlas-scientific-atlas-do)

## Duration

### [Weather: OpenWeatherMap (Lat/Lon, Current/Future)](/Mycodo/Supported-Inputs/#weather-openweathermap-lat-lon-current-future)

## Duty Cycle

### [Raspberry Pi: Signal (PWM)](/Mycodo/Supported-Inputs/#raspberry-pi-signal-pwm)

## GPIO Edge

### [Raspberry Pi: Edge Detection](/Mycodo/Supported-Inputs/#raspberry-pi-edge-detection)

## Electrical Conductivity

### [AnyLeaf: AnyLeaf EC](/Mycodo/Supported-Inputs/#anyleaf-anyleaf-ec)

### [Atlas Scientific: Atlas EC](/Mycodo/Supported-Inputs/#atlas-scientific-atlas-ec)

### [Texas Instruments: ADS1115: Generic Analog pH/EC](/Mycodo/Supported-Inputs/#texas-instruments-ads1115-generic-analog-ph-ec)

### [Texas Instruments: ADS1256: Generic Analog pH/EC](/Mycodo/Supported-Inputs/#texas-instruments-ads1256-generic-analog-ph-ec)

### [Xiaomi: Miflora](/Mycodo/Supported-Inputs/#xiaomi-miflora)

## Electrical Current

### [Power Monitor: RPi Power Monitor (6 Channels)](/Mycodo/Supported-Inputs/#power-monitor-rpi-power-monitor-6-channels)

### [TP-Link: Kasa WiFi Power Plug/Strip Energy Statistics](/Mycodo/Supported-Inputs/#tp-link-kasa-wifi-power-plug-strip-energy-statistics)

### [Tasmota: Tasmota Outlet Energy Monitor (HTTP)](/Mycodo/Supported-Inputs/#tasmota-tasmota-outlet-energy-monitor-http)

### [Texas Instruments: INA219x](/Mycodo/Supported-Inputs/#texas-instruments-ina219x)

## Electrical Potential

### [Microchip: MCP3008](/Mycodo/Supported-Inputs/#microchip-mcp3008)

### [Microchip: MCP3008](/Mycodo/Supported-Inputs/#microchip-mcp3008)

### [Microchip: MCP3208](/Mycodo/Supported-Inputs/#microchip-mcp3208)

### [Microchip: MCP342x (x=2,3,4,6,7,8)](/Mycodo/Supported-Inputs/#microchip-mcp342x-x=2-3-4-6-7-8)

### [Power Monitor: RPi Power Monitor (6 Channels)](/Mycodo/Supported-Inputs/#power-monitor-rpi-power-monitor-6-channels)

### [TP-Link: Kasa WiFi Power Plug/Strip Energy Statistics](/Mycodo/Supported-Inputs/#tp-link-kasa-wifi-power-plug-strip-energy-statistics)

### [Tasmota: Tasmota Outlet Energy Monitor (HTTP)](/Mycodo/Supported-Inputs/#tasmota-tasmota-outlet-energy-monitor-http)

### [Texas Instruments: ADS1015](/Mycodo/Supported-Inputs/#texas-instruments-ads1015)

### [Texas Instruments: ADS1115](/Mycodo/Supported-Inputs/#texas-instruments-ads1115)

### [Texas Instruments: ADS1256: Generic Analog pH/EC](/Mycodo/Supported-Inputs/#texas-instruments-ads1256-generic-analog-ph-ec)

### [Texas Instruments: ADS1256](/Mycodo/Supported-Inputs/#texas-instruments-ads1256)

### [Texas Instruments: ADS1x15](/Mycodo/Supported-Inputs/#texas-instruments-ads1x15)

### [Texas Instruments: INA219x](/Mycodo/Supported-Inputs/#texas-instruments-ina219x)

## Energy

### [TP-Link: Kasa WiFi Power Plug/Strip Energy Statistics](/Mycodo/Supported-Inputs/#tp-link-kasa-wifi-power-plug-strip-energy-statistics)

### [Tasmota: Tasmota Outlet Energy Monitor (HTTP)](/Mycodo/Supported-Inputs/#tasmota-tasmota-outlet-energy-monitor-http)

## Frequency

### [Raspberry Pi: Signal (PWM)](/Mycodo/Supported-Inputs/#raspberry-pi-signal-pwm)

## GPIO State

### [Raspberry Pi: GPIO State](/Mycodo/Supported-Inputs/#raspberry-pi-gpio-state)

## Humidity

### [AOSONG: AM2315/AM2320](/Mycodo/Supported-Inputs/#aosong-am2315-am2320)

### [AOSONG: DHT11](/Mycodo/Supported-Inputs/#aosong-dht11)

### [AOSONG: DHT22](/Mycodo/Supported-Inputs/#aosong-dht22)

### [ASAIR: AHTx0](/Mycodo/Supported-Inputs/#asair-ahtx0)

### [Atlas Scientific: Atlas Humidity](/Mycodo/Supported-Inputs/#atlas-scientific-atlas-humidity)

### [BOSCH: BME280](/Mycodo/Supported-Inputs/#bosch-bme280)

### [BOSCH: BME280](/Mycodo/Supported-Inputs/#bosch-bme280)

### [BOSCH: BME280](/Mycodo/Supported-Inputs/#bosch-bme280)

### [BOSCH: BME680](/Mycodo/Supported-Inputs/#bosch-bme680)

### [BOSCH: BME680](/Mycodo/Supported-Inputs/#bosch-bme680)

### [Cozir: Cozir CO2](/Mycodo/Supported-Inputs/#cozir-cozir-co2)

### [Raspberry Pi Foundation: Sense HAT](/Mycodo/Supported-Inputs/#raspberry-pi-foundation-sense-hat)

### [Ruuvi: RuuviTag](/Mycodo/Supported-Inputs/#ruuvi-ruuvitag)

### [Seeedstudio: DHT11/22](/Mycodo/Supported-Inputs/#seeedstudio-dht11-22)

### [Senseair: K96](/Mycodo/Supported-Inputs/#senseair-k96)

### [Sensirion: SCD-4x (40, 41)](/Mycodo/Supported-Inputs/#sensirion-scd-4x-40-41)

### [Sensirion: SCD30](/Mycodo/Supported-Inputs/#sensirion-scd30)

### [Sensirion: SCD30](/Mycodo/Supported-Inputs/#sensirion-scd30)

### [Sensirion: SHT1x/7x](/Mycodo/Supported-Inputs/#sensirion-sht1x-7x)

### [Sensirion: SHT2x](/Mycodo/Supported-Inputs/#sensirion-sht2x)

### [Sensirion: SHT2x](/Mycodo/Supported-Inputs/#sensirion-sht2x)

### [Sensirion: SHT31-D](/Mycodo/Supported-Inputs/#sensirion-sht31-d)

### [Sensirion: SHT3x (30, 31, 35)](/Mycodo/Supported-Inputs/#sensirion-sht3x-30-31-35)

### [Sensirion: SHT4X](/Mycodo/Supported-Inputs/#sensirion-sht4x)

### [Sensirion: SHTC3](/Mycodo/Supported-Inputs/#sensirion-shtc3)

### [Sensorion: SHT31 Smart Gadget](/Mycodo/Supported-Inputs/#sensorion-sht31-smart-gadget)

### [Silicon Labs: Si7021](/Mycodo/Supported-Inputs/#silicon-labs-si7021)

### [Sonoff: TH16/10 (Tasmota firmware) with AM2301/Si7021](/Mycodo/Supported-Inputs/#sonoff-th16-10-tasmota-firmware-with-am2301-si7021)

### [Sonoff: TH16/10 (Tasmota firmware) with AM2301](/Mycodo/Supported-Inputs/#sonoff-th16-10-tasmota-firmware-with-am2301)

### [TE Connectivity: HTU21D](/Mycodo/Supported-Inputs/#te-connectivity-htu21d)

### [TE Connectivity: HTU21D](/Mycodo/Supported-Inputs/#te-connectivity-htu21d)

### [Texas Instruments: HDC1000](/Mycodo/Supported-Inputs/#texas-instruments-hdc1000)

### [Weather: OpenWeatherMap (City, Current)](/Mycodo/Supported-Inputs/#weather-openweathermap-city-current)

### [Weather: OpenWeatherMap (Lat/Lon, Current/Future)](/Mycodo/Supported-Inputs/#weather-openweathermap-lat-lon-current-future)

### [Xiaomi: Mijia LYWSD03MMC (ATC and non-ATC modes)](/Mycodo/Supported-Inputs/#xiaomi-mijia-lywsd03mmc-atc-and-non-atc-modes)

## Ion Concentration

### [AnyLeaf: AnyLeaf pH](/Mycodo/Supported-Inputs/#anyleaf-anyleaf-ph)

### [Atlas Scientific: Atlas pH](/Mycodo/Supported-Inputs/#atlas-scientific-atlas-ph)

### [Texas Instruments: ADS1115: Generic Analog pH/EC](/Mycodo/Supported-Inputs/#texas-instruments-ads1115-generic-analog-ph-ec)

### [Texas Instruments: ADS1256: Generic Analog pH/EC](/Mycodo/Supported-Inputs/#texas-instruments-ads1256-generic-analog-ph-ec)

## Length

### [Atlas Scientific: Atlas Color](/Mycodo/Supported-Inputs/#atlas-scientific-atlas-color)

### [Multiple Manufacturers: HC-SR04](/Mycodo/Supported-Inputs/#multiple-manufacturers-hc-sr04)

### [STMicroelectronics: VL53L0X](/Mycodo/Supported-Inputs/#stmicroelectronics-vl53l0x)

### [STMicroelectronics: VL53L1X](/Mycodo/Supported-Inputs/#stmicroelectronics-vl53l1x)

### [STMicroelectronics: VL53L4CD](/Mycodo/Supported-Inputs/#stmicroelectronics-vl53l4cd)

### [Silicon Labs: SI1145](/Mycodo/Supported-Inputs/#silicon-labs-si1145)

## Light

### [AMS: TSL2561](/Mycodo/Supported-Inputs/#ams-tsl2561)

### [AMS: TSL2591](/Mycodo/Supported-Inputs/#ams-tsl2591)

### [Atlas Scientific: Atlas Color](/Mycodo/Supported-Inputs/#atlas-scientific-atlas-color)

### [Catnip Electronics: Chirp](/Mycodo/Supported-Inputs/#catnip-electronics-chirp)

### [ROHM: BH1750](/Mycodo/Supported-Inputs/#rohm-bh1750)

### [Silicon Labs: SI1145](/Mycodo/Supported-Inputs/#silicon-labs-si1145)

### [Xiaomi: Miflora](/Mycodo/Supported-Inputs/#xiaomi-miflora)

### [ams: AS7341](/Mycodo/Supported-Inputs/#ams-as7341)

## Magnetic Flux Density

### [Melexis: MLX90393](/Mycodo/Supported-Inputs/#melexis-mlx90393)

### [Raspberry Pi Foundation: Sense HAT](/Mycodo/Supported-Inputs/#raspberry-pi-foundation-sense-hat)

## Methane

### [Senseair: K96](/Mycodo/Supported-Inputs/#senseair-k96)

## Moisture

### [Adafruit: I2C Capacitive Moisture Sensor](/Mycodo/Supported-Inputs/#adafruit-i2c-capacitive-moisture-sensor)

### [Catnip Electronics: Chirp](/Mycodo/Supported-Inputs/#catnip-electronics-chirp)

### [Xiaomi: Miflora](/Mycodo/Supported-Inputs/#xiaomi-miflora)

## Oxygen

### [Atlas Scientific: Atlas O2 (Oxygen Gas)](/Mycodo/Supported-Inputs/#atlas-scientific-atlas-o2-oxygen-gas)

## Oxidation Reduction Potential

### [AnyLeaf: AnyLeaf ORP](/Mycodo/Supported-Inputs/#anyleaf-anyleaf-orp)

### [Atlas Scientific: Atlas ORP](/Mycodo/Supported-Inputs/#atlas-scientific-atlas-orp)

## PM10

### [Winsen: ZH03B](/Mycodo/Supported-Inputs/#winsen-zh03b)

## PM1

### [Winsen: ZH03B](/Mycodo/Supported-Inputs/#winsen-zh03b)

## PM2.5

### [Winsen: ZH03B](/Mycodo/Supported-Inputs/#winsen-zh03b)

## Power

### [Power Monitor: RPi Power Monitor (6 Channels)](/Mycodo/Supported-Inputs/#power-monitor-rpi-power-monitor-6-channels)

### [TP-Link: Kasa WiFi Power Plug/Strip Energy Statistics](/Mycodo/Supported-Inputs/#tp-link-kasa-wifi-power-plug-strip-energy-statistics)

### [Tasmota: Tasmota Outlet Energy Monitor (HTTP)](/Mycodo/Supported-Inputs/#tasmota-tasmota-outlet-energy-monitor-http)

## Apparent Power

### [Tasmota: Tasmota Outlet Energy Monitor (HTTP)](/Mycodo/Supported-Inputs/#tasmota-tasmota-outlet-energy-monitor-http)

## Power Factor

### [Power Monitor: RPi Power Monitor (6 Channels)](/Mycodo/Supported-Inputs/#power-monitor-rpi-power-monitor-6-channels)

### [Tasmota: Tasmota Outlet Energy Monitor (HTTP)](/Mycodo/Supported-Inputs/#tasmota-tasmota-outlet-energy-monitor-http)

## Reactive Power

### [Tasmota: Tasmota Outlet Energy Monitor (HTTP)](/Mycodo/Supported-Inputs/#tasmota-tasmota-outlet-energy-monitor-http)

## Pressure

### [Atlas Scientific: Atlas Pressure](/Mycodo/Supported-Inputs/#atlas-scientific-atlas-pressure)

### [BOSCH: BME280](/Mycodo/Supported-Inputs/#bosch-bme280)

### [BOSCH: BME280](/Mycodo/Supported-Inputs/#bosch-bme280)

### [BOSCH: BME280](/Mycodo/Supported-Inputs/#bosch-bme280)

### [BOSCH: BME680](/Mycodo/Supported-Inputs/#bosch-bme680)

### [BOSCH: BME680](/Mycodo/Supported-Inputs/#bosch-bme680)

### [BOSCH: BMP180](/Mycodo/Supported-Inputs/#bosch-bmp180)

### [BOSCH: BMP280](/Mycodo/Supported-Inputs/#bosch-bmp280)

### [BOSCH: BMP280](/Mycodo/Supported-Inputs/#bosch-bmp280)

### [Infineon: DPS310](/Mycodo/Supported-Inputs/#infineon-dps310)

### [Raspberry Pi Foundation: Sense HAT](/Mycodo/Supported-Inputs/#raspberry-pi-foundation-sense-hat)

### [Ruuvi: RuuviTag](/Mycodo/Supported-Inputs/#ruuvi-ruuvitag)

### [Senseair: K96](/Mycodo/Supported-Inputs/#senseair-k96)

### [Weather: OpenWeatherMap (City, Current)](/Mycodo/Supported-Inputs/#weather-openweathermap-city-current)

### [Weather: OpenWeatherMap (Lat/Lon, Current/Future)](/Mycodo/Supported-Inputs/#weather-openweathermap-lat-lon-current-future)

## Pulse Width

### [Raspberry Pi: Signal (PWM)](/Mycodo/Supported-Inputs/#raspberry-pi-signal-pwm)

## Volume Flow Rate

### [Atlas Scientific: Atlas Flow Meter](/Mycodo/Supported-Inputs/#atlas-scientific-atlas-flow-meter)

### [Generic: Hall Flow Meter](/Mycodo/Supported-Inputs/#generic-hall-flow-meter)

## Resistance

### [BOSCH: BME680](/Mycodo/Supported-Inputs/#bosch-bme680)

### [BOSCH: BME680](/Mycodo/Supported-Inputs/#bosch-bme680)

## Revolutions

### [Raspberry Pi: Signal (Revolutions) (pigpio method #1)](/Mycodo/Supported-Inputs/#raspberry-pi-signal-revolutions--pigpio-method-#1)

### [Raspberry Pi: Signal (Revolutions) (pigpio method #2)](/Mycodo/Supported-Inputs/#raspberry-pi-signal-revolutions--pigpio-method-#2)

## Salinity

### [Atlas Scientific: Atlas EC](/Mycodo/Supported-Inputs/#atlas-scientific-atlas-ec)

## Specific Gravity

### [Atlas Scientific: Atlas EC](/Mycodo/Supported-Inputs/#atlas-scientific-atlas-ec)

## Speed

### [Weather: OpenWeatherMap (City, Current)](/Mycodo/Supported-Inputs/#weather-openweathermap-city-current)

### [Weather: OpenWeatherMap (Lat/Lon, Current/Future)](/Mycodo/Supported-Inputs/#weather-openweathermap-lat-lon-current-future)

## Temperature

### [AMS: CCS811 (with Temperature)](/Mycodo/Supported-Inputs/#ams-ccs811-with-temperature)

### [AOSONG: AM2315/AM2320](/Mycodo/Supported-Inputs/#aosong-am2315-am2320)

### [AOSONG: DHT11](/Mycodo/Supported-Inputs/#aosong-dht11)

### [AOSONG: DHT22](/Mycodo/Supported-Inputs/#aosong-dht22)

### [ASAIR: AHTx0](/Mycodo/Supported-Inputs/#asair-ahtx0)

### [Adafruit: I2C Capacitive Moisture Sensor](/Mycodo/Supported-Inputs/#adafruit-i2c-capacitive-moisture-sensor)

### [Analog Devices: ADT7410](/Mycodo/Supported-Inputs/#analog-devices-adt7410)

### [Atlas Scientific: Atlas Humidity](/Mycodo/Supported-Inputs/#atlas-scientific-atlas-humidity)

### [Atlas Scientific: Atlas PT-1000](/Mycodo/Supported-Inputs/#atlas-scientific-atlas-pt-1000)

### [BOSCH: BME280](/Mycodo/Supported-Inputs/#bosch-bme280)

### [BOSCH: BME280](/Mycodo/Supported-Inputs/#bosch-bme280)

### [BOSCH: BME280](/Mycodo/Supported-Inputs/#bosch-bme280)

### [BOSCH: BME680](/Mycodo/Supported-Inputs/#bosch-bme680)

### [BOSCH: BME680](/Mycodo/Supported-Inputs/#bosch-bme680)

### [BOSCH: BMP180](/Mycodo/Supported-Inputs/#bosch-bmp180)

### [BOSCH: BMP280](/Mycodo/Supported-Inputs/#bosch-bmp280)

### [BOSCH: BMP280](/Mycodo/Supported-Inputs/#bosch-bmp280)

### [Catnip Electronics: Chirp](/Mycodo/Supported-Inputs/#catnip-electronics-chirp)

### [Cozir: Cozir CO2](/Mycodo/Supported-Inputs/#cozir-cozir-co2)

### [Infineon: DPS310](/Mycodo/Supported-Inputs/#infineon-dps310)

### [MAXIM: DS1822](/Mycodo/Supported-Inputs/#maxim-ds1822)

### [MAXIM: DS1825](/Mycodo/Supported-Inputs/#maxim-ds1825)

### [MAXIM: DS18B20](/Mycodo/Supported-Inputs/#maxim-ds18b20)

### [MAXIM: DS18B20](/Mycodo/Supported-Inputs/#maxim-ds18b20)

### [MAXIM: DS18S20](/Mycodo/Supported-Inputs/#maxim-ds18s20)

### [MAXIM: DS28EA00](/Mycodo/Supported-Inputs/#maxim-ds28ea00)

### [MAXIM: MAX31850K](/Mycodo/Supported-Inputs/#maxim-max31850k)

### [MAXIM: MAX31855 (Gravity PT100)](/Mycodo/Supported-Inputs/#maxim-max31855-gravity-pt100)

### [MAXIM: MAX31855 (Gravity PT100)](/Mycodo/Supported-Inputs/#maxim-max31855-gravity-pt100)

### [MAXIM: MAX31855](/Mycodo/Supported-Inputs/#maxim-max31855)

### [MAXIM: MAX31856](/Mycodo/Supported-Inputs/#maxim-max31856)

### [MAXIM: MAX31865](/Mycodo/Supported-Inputs/#maxim-max31865)

### [MAXIM: MAX31865](/Mycodo/Supported-Inputs/#maxim-max31865)

### [Melexis: MLX90614](/Mycodo/Supported-Inputs/#melexis-mlx90614)

### [Microchip: MCP9808](/Mycodo/Supported-Inputs/#microchip-mcp9808)

### [Panasonic: AMG8833](/Mycodo/Supported-Inputs/#panasonic-amg8833)

### [Raspberry Pi Foundation: Sense HAT](/Mycodo/Supported-Inputs/#raspberry-pi-foundation-sense-hat)

### [Raspberry Pi: CPU/GPU Temperature](/Mycodo/Supported-Inputs/#raspberry-pi-cpu-gpu-temperature)

### [Ruuvi: RuuviTag](/Mycodo/Supported-Inputs/#ruuvi-ruuvitag)

### [Seeedstudio: DHT11/22](/Mycodo/Supported-Inputs/#seeedstudio-dht11-22)

### [Senseair: K96](/Mycodo/Supported-Inputs/#senseair-k96)

### [Sensirion: SCD-4x (40, 41)](/Mycodo/Supported-Inputs/#sensirion-scd-4x-40-41)

### [Sensirion: SCD30](/Mycodo/Supported-Inputs/#sensirion-scd30)

### [Sensirion: SCD30](/Mycodo/Supported-Inputs/#sensirion-scd30)

### [Sensirion: SHT1x/7x](/Mycodo/Supported-Inputs/#sensirion-sht1x-7x)

### [Sensirion: SHT2x](/Mycodo/Supported-Inputs/#sensirion-sht2x)

### [Sensirion: SHT2x](/Mycodo/Supported-Inputs/#sensirion-sht2x)

### [Sensirion: SHT31-D](/Mycodo/Supported-Inputs/#sensirion-sht31-d)

### [Sensirion: SHT3x (30, 31, 35)](/Mycodo/Supported-Inputs/#sensirion-sht3x-30-31-35)

### [Sensirion: SHT4X](/Mycodo/Supported-Inputs/#sensirion-sht4x)

### [Sensirion: SHTC3](/Mycodo/Supported-Inputs/#sensirion-shtc3)

### [Sensorion: SHT31 Smart Gadget](/Mycodo/Supported-Inputs/#sensorion-sht31-smart-gadget)

### [Silicon Labs: Si7021](/Mycodo/Supported-Inputs/#silicon-labs-si7021)

### [Sonoff: TH16/10 (Tasmota firmware) with AM2301/Si7021](/Mycodo/Supported-Inputs/#sonoff-th16-10-tasmota-firmware-with-am2301-si7021)

### [Sonoff: TH16/10 (Tasmota firmware) with AM2301](/Mycodo/Supported-Inputs/#sonoff-th16-10-tasmota-firmware-with-am2301)

### [Sonoff: TH16/10 (Tasmota firmware) with DS18B20](/Mycodo/Supported-Inputs/#sonoff-th16-10-tasmota-firmware-with-ds18b20)

### [TE Connectivity: HTU21D](/Mycodo/Supported-Inputs/#te-connectivity-htu21d)

### [TE Connectivity: HTU21D](/Mycodo/Supported-Inputs/#te-connectivity-htu21d)

### [Texas Instruments: HDC1000](/Mycodo/Supported-Inputs/#texas-instruments-hdc1000)

### [Texas Instruments: TMP006](/Mycodo/Supported-Inputs/#texas-instruments-tmp006)

### [Weather: OpenWeatherMap (City, Current)](/Mycodo/Supported-Inputs/#weather-openweathermap-city-current)

### [Weather: OpenWeatherMap (Lat/Lon, Current/Future)](/Mycodo/Supported-Inputs/#weather-openweathermap-lat-lon-current-future)

### [Xiaomi: Miflora](/Mycodo/Supported-Inputs/#xiaomi-miflora)

### [Xiaomi: Mijia LYWSD03MMC (ATC and non-ATC modes)](/Mycodo/Supported-Inputs/#xiaomi-mijia-lywsd03mmc-atc-and-non-atc-modes)

## Total Dissolved Solids

### [Atlas Scientific: Atlas EC](/Mycodo/Supported-Inputs/#atlas-scientific-atlas-ec)

## Vapor Pressure Deficit

### [AOSONG: AM2315/AM2320](/Mycodo/Supported-Inputs/#aosong-am2315-am2320)

### [AOSONG: DHT11](/Mycodo/Supported-Inputs/#aosong-dht11)

### [AOSONG: DHT22](/Mycodo/Supported-Inputs/#aosong-dht22)

### [BOSCH: BME280](/Mycodo/Supported-Inputs/#bosch-bme280)

### [BOSCH: BME280](/Mycodo/Supported-Inputs/#bosch-bme280)

### [BOSCH: BME280](/Mycodo/Supported-Inputs/#bosch-bme280)

### [BOSCH: BME680](/Mycodo/Supported-Inputs/#bosch-bme680)

### [BOSCH: BME680](/Mycodo/Supported-Inputs/#bosch-bme680)

### [Ruuvi: RuuviTag](/Mycodo/Supported-Inputs/#ruuvi-ruuvitag)

### [Seeedstudio: DHT11/22](/Mycodo/Supported-Inputs/#seeedstudio-dht11-22)

### [Senseair: K96](/Mycodo/Supported-Inputs/#senseair-k96)

### [Sensirion: SCD-4x (40, 41)](/Mycodo/Supported-Inputs/#sensirion-scd-4x-40-41)

### [Sensirion: SCD30](/Mycodo/Supported-Inputs/#sensirion-scd30)

### [Sensirion: SCD30](/Mycodo/Supported-Inputs/#sensirion-scd30)

### [Sensirion: SHT1x/7x](/Mycodo/Supported-Inputs/#sensirion-sht1x-7x)

### [Sensirion: SHT2x](/Mycodo/Supported-Inputs/#sensirion-sht2x)

### [Sensirion: SHT2x](/Mycodo/Supported-Inputs/#sensirion-sht2x)

### [Sensirion: SHT31-D](/Mycodo/Supported-Inputs/#sensirion-sht31-d)

### [Sensirion: SHT3x (30, 31, 35)](/Mycodo/Supported-Inputs/#sensirion-sht3x-30-31-35)

### [Sensirion: SHT4X](/Mycodo/Supported-Inputs/#sensirion-sht4x)

### [Sensirion: SHTC3](/Mycodo/Supported-Inputs/#sensirion-shtc3)

### [Sensorion: SHT31 Smart Gadget](/Mycodo/Supported-Inputs/#sensorion-sht31-smart-gadget)

### [Silicon Labs: Si7021](/Mycodo/Supported-Inputs/#silicon-labs-si7021)

### [Sonoff: TH16/10 (Tasmota firmware) with AM2301/Si7021](/Mycodo/Supported-Inputs/#sonoff-th16-10-tasmota-firmware-with-am2301-si7021)

### [Sonoff: TH16/10 (Tasmota firmware) with AM2301](/Mycodo/Supported-Inputs/#sonoff-th16-10-tasmota-firmware-with-am2301)

### [TE Connectivity: HTU21D](/Mycodo/Supported-Inputs/#te-connectivity-htu21d)

### [TE Connectivity: HTU21D](/Mycodo/Supported-Inputs/#te-connectivity-htu21d)

### [Texas Instruments: HDC1000](/Mycodo/Supported-Inputs/#texas-instruments-hdc1000)

## Version

### [Mycodo: Mycodo Version](/Mycodo/Supported-Inputs/#mycodo-mycodo-version)

## VOC

### [AMS: CCS811 (with Temperature)](/Mycodo/Supported-Inputs/#ams-ccs811-with-temperature)

### [AMS: CCS811 (without Temperature)](/Mycodo/Supported-Inputs/#ams-ccs811-without-temperature)

## Volume

### [Atlas Scientific: Atlas Flow Meter](/Mycodo/Supported-Inputs/#atlas-scientific-atlas-flow-meter)

### [Generic: Hall Flow Meter](/Mycodo/Supported-Inputs/#generic-hall-flow-meter)

