description: Documentation for Mycodo, an open source environmental monitoring and regulation system.

## Mycodo System zur Überwachung und Regulierung der Umwelt

Mycodo ist eine Open-Source-Software, die auf dem [Raspberry Pi](https://en.wikipedia.org/wiki/Raspberry_Pi) und anderen Einplatinencomputern (SBCs) läuft. Sie verknüpft Ein- und Ausgänge auf interessante Weise, um die Umgebung zu erfassen und zu manipulieren.

### Informationen

Siehe die [README](https://github.com/kizniche/Mycodo#uses) für Funktionen, Projekte, die Mycodo verwenden, Screenshots und andere Informationen.

### Voraussetzungen

*   Einplatinencomputer (empfohlen: [Raspberry Pi](https://www.raspberrypi.org/), beliebige Version: Zero, 1, 2, 3, oder 4)
*   Debian-basiertes Betriebssystem
*   Eine aktive Internetverbindung

### Installieren Sie

Sobald Sie hochgefahren und eingeloggt sind, führen Sie den folgenden Befehl aus, um die Installation von Mycodo zu starten:

```bash
curl -L https://kizniche.github.io/Mycodo/install | bash
```

Öffnen Sie nach der Installation einen Webbrowser mit der IP-Adresse des SBC und Sie werden aufgefordert, einen Admin-Benutzer zu erstellen und sich anzumelden.

```
https://127.0.0.1
```

### Unterstützung

*   [Mycodo on GitHub](https://github.com/kizniche/Mycodo)
*   [Mycodo Wiki](https://github.com/kizniche/Mycodo/wiki)
*   [Mycodo API](https://kizniche.github.io/Mycodo/mycodo-api.html)
*   [Diskussionsforum](https://forum.radicaldiy.com)
*   [Häufig gestellte Fragen](https://forum.radicaldiy.com/docs?category=23&tags=mycodo)
*   [Mycodo Support](https://play.google.com/store/apps/details?id=com.mycodo.mycododocs) (Android App)

### Spenden Sie

Sponsor werden: [github.com/sponsors/kizniche](https://github.com/sponsors/kizniche)

Andere Methoden: [KyleGabriel.com/donate](https://kylegabriel.com/donate)
