description: Documentation for Mycodo, an open source environmental monitoring and regulation system.

## Sistema de control y regulación medioambiental Mycodo

Mycodo es un software de código abierto diseñado para funcionar en la [Raspberry Pi](https://en.wikipedia.org/wiki/Raspberry_Pi) y otros ordenadores de placa única (SBC). Acopla las entradas y salidas de forma interesante para percibir y manipular el entorno.

### Información

Consulte el [README](https://github.com/kizniche/Mycodo#uses) para conocer las características, los proyectos que utilizan Mycodo, las capturas de pantalla y otra información.

### Requisitos previos

*   Ordenador monoplaca (Recomendado: [Raspberry Pi](https://www.raspberrypi.org/), cualquier versión: Cero, 1, 2, 3 o 4)
*   Sistema operativo basado en Debian
*   Una conexión a Internet activa

### Instalar

Una vez arrancado y conectado, ejecute el siguiente comando para iniciar la instalación de Mycodo:

```bash
curl -L https://kizniche.github.io/Mycodo/install | bash
```

Después de la instalación, abra un navegador web a la dirección IP del SBC y se le pedirá que cree un usuario administrador e inicie sesión.

```
https://127.0.0.1
```

### Soporte

*   [Mycodo on GitHub](https://github.com/kizniche/Mycodo)
*   [Mycodo Wiki](https://github.com/kizniche/Mycodo/wiki)
*   [Mycodo API](https://kizniche.github.io/Mycodo/mycodo-api.html)
*   [Foro de discusion](https://forum.radicaldiy.com)
*   [Preguntas frecuentes](https://forum.radicaldiy.com/docs?category=23&tags=mycodo)
*   [Mycodo Support](https://play.google.com/store/apps/details?id=com.mycodo.mycododocs) (Android App)

### Donar

Conviértase en patrocinador: [github.com/sponsors/kizniche](https://github.com/sponsors/kizniche)

Otros métodos: [KyleGabriel.com/donate](https://kylegabriel.com/donate)
