description: Documentation for Mycodo, an open source environmental monitoring and regulation system.

## Sistema di monitoraggio e regolazione ambientale Mycodo

Mycodo è un software open source progettato per funzionare su [Raspberry Pi](https://en.wikipedia.org/wiki/Raspberry_Pi) e altri computer a scheda singola (SBC). Accoppia ingressi e uscite in modi interessanti per percepire e manipolare l'ambiente.

### Informazioni

Si veda il [README](https://github.com/kizniche/Mycodo#uses) per le caratteristiche, i progetti che utilizzano Mycodo, gli screenshot e altre informazioni.

### Prerequisiti

*   Computer a scheda singola (consigliato: [Raspberry Pi](https://www.raspberrypi.org/), qualsiasi versione: Zero, 1, 2, 3 o 4)
*   Sistema operativo basato su Debian
*   Una connessione internet attiva

### Installare

Una volta avviato e collegato, eseguire il seguente comando per avviare l'installazione di Mycodo:

```bash
curl -L https://kizniche.github.io/Mycodo/install | bash
```

Dopo l'installazione, aprire un browser web all'indirizzo IP dell'SBC e verrà richiesto di creare un utente amministratore e di effettuare il login.

```
https://127.0.0.1
```

### Supporto

*   [Mycodo on GitHub](https://github.com/kizniche/Mycodo)
*   [Mycodo Wiki](https://github.com/kizniche/Mycodo/wiki)
*   [Mycodo API](https://kizniche.github.io/Mycodo/mycodo-api.html)
*   [Forum di discussione](https://forum.radicaldiy.com)
*   [Domande frequenti](https://forum.radicaldiy.com/docs?category=23&tags=mycodo)
*   [Mycodo Support](https://play.google.com/store/apps/details?id=com.mycodo.mycododocs) (Android App)

### Dona

Diventare sponsor: [github.com/sponsors/kizniche](https://github.com/sponsors/kizniche)

Altri metodi: [KyleGabriel.com/donate](https://kylegabriel.com/donate)
