description: Documentation for Mycodo, an open source environmental monitoring and regulation system.

## Mycodo Environmental Monitoring and Regulation System

Mycodo is open source software designed to run on the [Raspberry Pi](https://en.wikipedia.org/wiki/Raspberry_Pi) and other single-board computers (SBCs). It couples inputs and outputs in interesting ways to sense and manipulate the environment.

### Information

See the [README](https://github.com/kizniche/Mycodo#uses) for features, projects using Mycodo, screenshots, and other information.

### Prerequisites

*   Single-board computer (Recommended: [Raspberry Pi](https://www.raspberrypi.org/), any version: Zero, 1, 2, 3, or 4)
*   Debian-based operating system
*   An active internet connection

### Install

Once booted and logged in, run the following command to initiate the Mycodo install:

```bash
curl -L https://kizniche.github.io/Mycodo/install | bash
```

After installation, open a web browser to the SBC's IP address and you will be prompted to create an Admin user and login.

```
https://127.0.0.1
```

### Support

*   [Mycodo on GitHub](https://github.com/kizniche/Mycodo)
*   [Mycodo Wiki](https://github.com/kizniche/Mycodo/wiki)
*   [Mycodo API](https://kizniche.github.io/Mycodo/mycodo-api.html)
*   [Discussion Forum](https://forum.radicaldiy.com)
*   [Frequently Asked Questions](https://forum.radicaldiy.com/docs?category=23&tags=mycodo)
*   [Mycodo Support](https://play.google.com/store/apps/details?id=com.mycodo.mycododocs) (Android App)

### Donate

Become a Sponsor: [github.com/sponsors/kizniche](https://github.com/sponsors/kizniche)

Other Methods: [KyleGabriel.com/donate](https://kylegabriel.com/donate)
