description: Documentation for Mycodo, an open source environmental monitoring and regulation system.

## System monitorowania i regulacji środowiska Mycodo

Mycodo to oprogramowanie open source przeznaczone do uruchamiania na [Raspberry Pi](https://en.wikipedia.org/wiki/Raspberry_Pi) i innych komputerach jednopłytkowych (SBC). Łączy wejścia i wyjścia w interesujący sposób, aby wyczuć i manipulować środowiskiem.

### Informacje

Zobacz [README](https://github.com/kizniche/Mycodo#uses), aby poznać funkcje, projekty wykorzystujące Mycodo, zrzuty ekranu i inne informacje.

### Wymagania wstępne

*   Komputer jednopłytkowy (Zalecane: [Raspberry Pi](https://www.raspberrypi.org/), dowolna wersja: Zero, 1, 2, 3 lub 4)
*   System operacyjny oparty na Debianie
*   Aktywne połączenie internetowe

### Zainstaluj

Po uruchomieniu i zalogowaniu się, uruchom następujące polecenie, aby zainicjować instalację Mycodo:

```bash
curl -L https://kizniche.github.io/Mycodo/install | bash
```

Po instalacji otwórz przeglądarkę internetową na adres IP SBC, a zostaniesz poproszony o utworzenie użytkownika Admin i zalogowanie się.

```
https://127.0.0.1
```

### Wsparcie

*   [Mycodo on GitHub](https://github.com/kizniche/Mycodo)
*   [Mycodo Wiki](https://github.com/kizniche/Mycodo/wiki)
*   [Mycodo API](https://kizniche.github.io/Mycodo/mycodo-api.html)
*   [Forum dyskusyjne](https://forum.radicaldiy.com)
*   [Najczęściej zadawane pytania](https://forum.radicaldiy.com/docs?category=23&tags=mycodo)
*   [Mycodo Support](https://play.google.com/store/apps/details?id=com.mycodo.mycododocs) (Android App)

### Darowizna

Zostań sponsorem: [github.com/sponsors/kizniche](https://github.com/sponsors/kizniche)

Inne metody: [KyleGabriel.com/donate](https://kylegabriel.com/donate)
