description: Documentation for Mycodo, an open source environmental monitoring and regulation system.

## Sistema de Monitorização e Regulação Ambiental Mycodo

Mycodo é software de código aberto concebido para correr no [Raspberry Pi](https://en.wikipedia.org/wiki/Raspberry_Pi) e noutros computadores de placa única (SBCs). Combina entradas e saídas de formas interessantes para sentir e manipular o ambiente.

### Informação

Ver o [README](https://github.com/kizniche/Mycodo#uses) para características, projectos utilizando Mycodo, capturas de ecrã, e outras informações.

### Pré-requisitos

*   Computador de placa única (Recomendado: [Raspberry Pi](https://www.raspberrypi.org/), qualquer versão: Zero, 1, 2, 3, ou 4)
*   Sistema operativo baseado em Debian
*   Uma ligação activa à Internet

### Instalar

Uma vez iniciados e logados, executar o seguinte comando para iniciar a instalação do Mycodo:

```bash
curl -L https://kizniche.github.io/Mycodo/install | bash
```

Após a instalação, abra um web browser para o endereço IP da SBC e ser-lhe-á pedido que crie um utilizador Admin e faça o login.

```
https://127.0.0.1
```

### Apoio

*   [Mycodo on GitHub](https://github.com/kizniche/Mycodo)
*   [Mycodo Wiki](https://github.com/kizniche/Mycodo/wiki)
*   [Mycodo API](https://kizniche.github.io/Mycodo/mycodo-api.html)
*   [Fórum de discussão](https://forum.radicaldiy.com)
*   [Perguntas Mais Frequentes](https://forum.radicaldiy.com/docs?category=23&tags=mycodo)
*   [Mycodo Support](https://play.google.com/store/apps/details?id=com.mycodo.mycododocs) (Android App)

### Faça o seu donativo

Torne-se um Patrocinador: [github.com/sponsors/kizniche](https://github.com/sponsors/kizniche)

Outros métodos: [KyleGabriel.com/donate](https://kylegabriel.com/donate)
