description: Documentation for Mycodo, an open source environmental monitoring and regulation system.

## System för miljöövervakning och miljöreglering av Mycodo

Mycodo är en programvara med öppen källkod som är utformad för att köras på [Raspberry Pi](https://en.wikipedia.org/wiki/Raspberry_Pi) och andra enbordsdatorer (SBC). Den kopplar ihop in- och utgångar på intressanta sätt för att känna av och manipulera miljön.

### Information

Se [README](https://github.com/kizniche/Mycodo#uses) för funktioner, projekt som använder Mycodo, skärmdumpar och annan information.

### Förutsättningar

*   Enbordsdator (Rekommenderas: [Raspberry Pi](https://www.raspberrypi.org/), vilken version som helst: Zero, 1, 2, 3 eller 4)
*   Debianbaserat operativsystem
*   En aktiv internetanslutning

### Installera

När du har startat upp och loggat in kör du följande kommando för att påbörja Mycodo-installationen:

```bash
curl -L https://kizniche.github.io/Mycodo/install | bash
```

Efter installationen öppnar du en webbläsare till SBC:s IP-adress och du kommer att uppmanas att skapa en administratörsanvändare och logga in.

```
https://127.0.0.1
```

### Stöd

*   [Mycodo on GitHub](https://github.com/kizniche/Mycodo)
*   [Mycodo Wiki](https://github.com/kizniche/Mycodo/wiki)
*   [Mycodo API](https://kizniche.github.io/Mycodo/mycodo-api.html)
*   [Diskussionsforum](https://forum.radicaldiy.com)
*   [Ofta ställda frågor](https://forum.radicaldiy.com/docs?category=23&tags=mycodo)
*   [Mycodo Support](https://play.google.com/store/apps/details?id=com.mycodo.mycododocs) (Android App)

### Donera

Bli en sponsor: [github.com/sponsors/kizniche](https://github.com/sponsors/kizniche)

Andra metoder: [KyleGabriel.com/donate](https://kylegabriel.com/donate)
