description: Documentation for Mycodo, an open source environmental monitoring and regulation system.

## Mycodo环境监测和监管系统

Mycodo是开源软件，旨在运行在[树莓派](https://en.wikipedia.org/wiki/Raspberry_Pi)和其他单板计算机(SBC)上。它以有趣的方式将输入和输出耦合起来，以感知和操纵环境。

### Information

有关功能、使用Mycodo的项目、屏幕截图和其他信息，请参见[README](https://github.com/kizniche/Mycodo#uses)。

### 先决条件

*   单板计算机（推荐。[Raspberry Pi](https://www.raspberrypi.org/)，任何版本。零，1，2，3，或4)
*   基于Debian的操作系统
*   一个活跃的互联网连接

### 安装

启动并登录后，运行以下命令，启动Mycodo安装。

```bash
curl -L https://kizniche.github.io/Mycodo/install | bash
```

安装后，打开Web浏览器到SBC的IP地址，会提示你创建一个管理员用户并登录。

```
https://127.0.0.1
```

### Support

*   [Mycodo on GitHub](https://github.com/kizniche/Mycodo)
*   [Mycodo Wiki](https://github.com/kizniche/Mycodo/wiki)
*   [Mycodo API](https://kizniche.github.io/Mycodo/mycodo-api.html)
*   [论坛](https://forum.radicaldiy.com)
*   [常见问题](https://forum.radicaldiy.com/docs?category=23&tags=mycodo)
*   [Mycodo Support](https://play.google.com/store/apps/details?id=com.mycodo.mycododocs) (Android App)

### 捐赠

成为赞助商: [github.com/sponsors/kizniche](https://github.com/sponsors/kizniche)

Other Methods: [KyleGabriel.com/donate](https://kylegabriel.com/donate)
