description: Documentation for Mycodo, an open source environmental monitoring and regulation system.

## Système de surveillance et de régulation environnementale Mycodo

Mycodo est un logiciel open source conçu pour fonctionner sur le [Raspberry Pi](https://en.wikipedia.org/wiki/Raspberry_Pi) et d'autres ordinateurs monocartes (SBC). Il couple les entrées et les sorties de manière intéressante pour détecter et manipuler l'environnement.

### Informations

Voir le [README](https://github.com/kizniche/Mycodo#uses) pour les fonctionnalités, les projets utilisant Mycodo, les captures d'écran et d'autres informations.

### Conditions préalables

*   Ordinateur monocarte (recommandé : [Raspberry Pi](https://www.raspberrypi.org/), toute version : Zero, 1, 2, 3, ou 4)
*   Système d'exploitation basé sur Debian
*   Une connexion internet active

### Installer

Une fois démarré et connecté, exécutez la commande suivante pour lancer l'installation de Mycodo :

```bash
curl -L https://kizniche.github.io/Mycodo/install | bash
```

Après l'installation, ouvrez un navigateur Web sur l'adresse IP du SBC et vous serez invité à créer un utilisateur Admin et à vous connecter.

```
https://127.0.0.1
```

### Soutien

*   [Mycodo on GitHub](https://github.com/kizniche/Mycodo)
*   [Mycodo Wiki](https://github.com/kizniche/Mycodo/wiki)
*   [Mycodo API](https://kizniche.github.io/Mycodo/mycodo-api.html)
*   [Forum de discussion](https://forum.radicaldiy.com)
*   [Questions fréquemment posées](https://forum.radicaldiy.com/docs?category=23&tags=mycodo)
*   [Mycodo Support](https://play.google.com/store/apps/details?id=com.mycodo.mycododocs) (Android App)

### Faire un don

Devenir un sponsor: [github.com/sponsors/kizniche](https://github.com/sponsors/kizniche)

Autres méthodes: [KyleGabriel.com/donate](https://kylegabriel.com/donate)
